
;	mirrorX by jimi

;copies the graph screen to the current screen reflected over the X axis and then exits
;can be used from ti-basic once image is loaded onto the graph screen
;will copy the axis if they are currently displayed (see below for information on how to turn off axis at start of routine)

_plotSScreen		=$c9fa		;1024 byte area for graph screen image
_asm_exec_ram		=$d748		;start address of assembly programs

.org _asm_exec_ram

;					;if you want to get rid of the axis (if they are turned on) then use
;					; two lines to set the appropriate flags
;					;usually people will have already turned
;	set grfnoaxis, (iy+grfdbflags)	;get rid of the axis
;	set graphdraw, (iy+graphflags)	;to finally get rid of axis have to tell it to regraph all functions

	ld hl,_plotSScreen

;===============================================================
;  mirror over x-axis
;	input:	hl points to start of data to mirror (for graph screen it's "ld hl,_plotSScreen")
;	output:	image relfected over x-axis
;		b = $00
;		de = $fbf0
;		hl = $0000
;===============================================================
mirror_x_axis:
	ld de,$10000-16			;$fc00+$0400=$10000 (which we can't have)
					;video memory of where to copy to ($0400=1024)
	ld b,64				;height of screen in pixels (1 pixel= 1 row)
mirror_x_axis_loop:
		push bc			;save our loop counter (b)
	ld bc,16			;16 bytes in a row
	ldir				;copy that row finishing with hl pointing to start of next row to do and
					; de pointing 16*2 bytes ahead of the row we need it to be on
					; next loop
	ld b,16*2			;we need to get rid of two 16 byte increases:
					; 1) addition from 'ldir'
					; 2) go back one row for next loop to start
subtract_loop:
	dec de
	djnz subtract_loop			;decrease de 16*2 (32) times
		pop bc			;get back our loop counter
	djnz mirror_x_axis_loop		;decrease counter so we repeate for all 64 rows of pixels
	ret				;return to calling program
;===============================================================
.end